#include<bits/stdc++.h>
#define ll long long
using namespace std;
int main()
{
    int t,n,k;
    vector<ll> a;
    deque<int> b;
    cin>>t>>n>>k;
    for(int i=0;i<n;i++)
    {
        ll o;
        cin>>o;
        a.push_back(o);
    }
    sort(a.begin(),a.end());
    int x;
    if((n-k)%2==1)
    {
        cout<<"NE";
        return 0;
    }
    x=(n-k)/2;
   for(int i=0;i<x;i++){
        b.push_front(a[i]);

   }
   for(int i=n-1;i>=x;i--)
   {
       b.push_front(a[i]);
   }
       cout<<"DA"<<endl;
       for(int i:b)
       {
           cout<<i<<" ";
       }

}